	.ORIG	x3000
	LD	R6, STACK	; initialize the stack pointer

; set up keyboard interrupt vector table
	LD	R0, VECTOR	
	LD	R1, INTADDR
	ADD	R1, R1, R0	; address in interrupt vector table
	LD	R2, ROUTINE	; address of interrupt service routine
	STR	R2, R1, #0	; set routine address to vector table

; set IE bit 14 to 1
	LD	R3, KBSR	
	NOT	R3, R3
	LD	R4, MASK
	AND	R3, R3, R4
	NOT	R3, R3
	ST	R3, KBSR

; print lines
PRINT1	LEA	R1, USTC
	LEA	R7, #1
	BRnzp	PRINT
	JSR	DELAY
PRINT2	LEA	R1, SPACE
	LEA	R7, #1
	BRnzp	PRINT
	JSR	DELAY
	BRnzp	PRINT1

;delay subroutine
DELAY   ST	R1, SaveR1
        LD	R1, COUNT
REP     ADD	R1, R1, #-1
        BRp	REP
        LD	R1, SaveR1
        RET
COUNT   .FILL #2500
SaveR1  .BLKW 1

;print string subroutine
PRINT	ST	R0, SAVER0
	ST	R1, SAVER1
	ST	R2, SAVER2
NEXT	LDR	R0, R1, #0	;R1 should store the pointer
	BRz	RETURN
ECHO	LDI	R2, DSR		;echo
	BRzp	ECHO
	STI	R0, DDR
	ADD	R1, R1, #1
	BRnzp	NEXT
RETURN	LD	R0, NEWLINE
WAIT	LDI	R2, DSR
	BRzp	WAIT
	STI	R0, DDR

	LD	R0, SAVER0
	LD	R1, SAVER1
	LD	R2, SAVER2
	RET			;return to address set by caller
SAVER0	.BLKW	1
SAVER1	.BLKW	1
SAVER2	.BLKW	1

STACK	.FILL	x3000
VECTOR	.FILL	x0080
INTADDR	.FILL	x0100
ROUTINE	.FILL	x2000
MASK	.FILL	xBFFF		;1011 1111 1111 1111
KBSR	.FILL	xFE00
KBDR	.FILL	xFE02
DSR	.FILL	xFE04
DDR	.FILL	xFE06
USTC	.STRINGZ "USTC    USTC    USTC    USTC    USTC    USTC"
SPACE	.STRINGZ "    USTC    USTC    USTC    USTC    USTC    "
NEWLINE	.FILL	x000A
	.END